-- Copyright (C) 2020  Intel Corporation. All rights reserved.
-- Your use of Intel Corporation's design tools, logic functions 
-- and other software and tools, and any partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Intel Program License 
-- Subscription Agreement, the Intel Quartus Prime License Agreement,
-- the Intel FPGA IP License Agreement, or other applicable license
-- agreement, including, without limitation, that your use is for
-- the sole purpose of programming logic devices manufactured by
-- Intel and sold by Intel or its authorized distributors.  Please
-- refer to the applicable agreement for further details, at
-- https://fpgasoftware.intel.com/eula.

-- ***************************************************************************
-- This file contains a Vhdl test bench template that is freely editable to   
-- suit user's needs .Comments are provided in each section to help the user  
-- fill out necessary details.                                                
-- ***************************************************************************
-- Generated on "03/28/2024 20:54:33"
                                                            
-- Vhdl Test Bench template for design  :  ALU_9bit
-- 
-- Simulation tool : ModelSim-Altera (VHDL)
-- 

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY ALU_9bit_vhd_tst IS
END ALU_9bit_vhd_tst;

ARCHITECTURE ALU_9bit_arch OF ALU_9bit_vhd_tst IS
-- constants                                                 
-- signals                                                   
SIGNAL A : STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL B : STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL C : STD_LOGIC;
SIGNAL EQ : STD_LOGIC;
SIGNAL HEX0_L : STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL HEX1_L : STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL HEX2_L : STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL HEX3_L : STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL HEX4_L : STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL HEX5_L : STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL LED : STD_LOGIC_VECTOR(9 DOWNTO 0);
SIGNAL N : STD_LOGIC;
SIGNAL OP : STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL OV : STD_LOGIC;
SIGNAL R : STD_LOGIC_VECTOR(17 DOWNTO 0);
SIGNAL Z : STD_LOGIC;


COMPONENT ALU_9bit
	PORT (
	A : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
	B : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
	C : BUFFER STD_LOGIC;
	EQ : BUFFER STD_LOGIC;
	HEX0_L : BUFFER STD_LOGIC_VECTOR(7 DOWNTO 0);
	HEX1_L : BUFFER STD_LOGIC_VECTOR(7 DOWNTO 0);
	HEX2_L : BUFFER STD_LOGIC_VECTOR(7 DOWNTO 0);
	HEX3_L : BUFFER STD_LOGIC_VECTOR(7 DOWNTO 0);
	HEX4_L : BUFFER STD_LOGIC_VECTOR(7 DOWNTO 0);
	HEX5_L : BUFFER STD_LOGIC_VECTOR(7 DOWNTO 0);
	LED : BUFFER STD_LOGIC_VECTOR(9 DOWNTO 0);
	N : BUFFER STD_LOGIC;
	OP : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
	OV : BUFFER STD_LOGIC;
	R : BUFFER STD_LOGIC_VECTOR(17 DOWNTO 0);
	Z : BUFFER STD_LOGIC
	);
END COMPONENT;

-- Time references  
-- ***************************************************************************
   constant Min_Pulse: time := 15.25 us; --- run simulation for 1 ms
   

BEGIN
	i1 : ALU_9bit
	PORT MAP (
-- list connections between master ports and signals
	A => A,
	B => B,
	C => C,
	EQ => EQ,
	HEX0_L => HEX0_L,
	HEX1_L => HEX1_L,
	HEX2_L => HEX2_L,
	HEX3_L => HEX3_L,
	HEX4_L => HEX4_L,
	HEX5_L => HEX5_L,
	LED => LED,
	N => N,
	OP => OP,
	OV => OV,
	R => R,
	Z => Z
	);
	
	
	
stim_proc: process
   begin		
     
      wait for 70 ns;	
		wait for Min_Pulse*5.2;
		
	-- ACTIVITY:Logic bitwise operations
     	A <= "101010100"; 		
		B <= "010111110"; 		
		OP <= "000";			-- or 
		wait for Min_Pulse*2.2;
		
     	A <= "101010100"; 		
		B <= "010111110"; 		
		OP <= "001";			-- and 
		wait for Min_Pulse*2.2;

     	A <= "101010100"; 		
		B <= "010111110"; 		
		OP <= "010";			-- xor 
		wait for Min_Pulse*2.2;
				
     	A <= "101010100"; 		
		B <= "010111110"; 		
		OP <= "011";			-- not(A) 
		wait for Min_Pulse*10.2;
				
	---- Arithmetic operations			
		A <= "110000110"; --  (-122)
		B <= "000001100"; --  (+12)
		OP <= "100";			-- add A+B
		wait for Min_Pulse*2.2;

		A <= "000100001"; --  (+33)
		B <= "110011010"; --  (-102)
		OP <= "100"; 			 -- add A+B
		wait for Min_Pulse*3.2;
		
		A <= "110000110"; --  (-122)
		B <= "000001000"; --  (+8)
		OP <= "100";			-- add A+B
		wait for Min_Pulse*3.2;

    	A <= "000001010"; 	-- (+10)
		B <= "000000110"; 	-- (+6)
		OP <= "101";		    -- subtract A-B
		wait for Min_Pulse*2.2;
		
		A <= "110001111"; -- (-113)
		B <= "101110001"; -- (+113)
		OP <= "101";			-- subtract A-B
		wait for Min_Pulse*3.2;
		
		A <= "110000110"; --  (-122)
		B <= "111110100"; --  (-12)
		OP <= "101";			-- subtract A-B
		wait for Min_Pulse*2.2;

		A <= "000100001"; --  (+33)
		B <= "110011010"; --  (-102)
		OP <= "101";			-- subtract A-B
		wait for Min_Pulse*3.2;
		
		A <= "110000110"; --  (-122)
		B <= "000001000"; --  (+8)
		OP <= "101";			-- subtract A-B
		wait for Min_Pulse*3.2;
		
		A <= "110000110"; --  (-122)
		B <= "000001000"; --  (+8)
		OP <= "110";			--  2C(B) = B' +1 
		wait for Min_Pulse*3.2;
				
		A <= "000100001"; --  (+33)
		B <= "110011010"; --  (-102)
		OP <=  "110";			--  2C(B) = B' +1 
		wait for Min_Pulse*3.2;		
		
		A <= "000100001"; --  (+33)
		B <= "110011010"; --  (-102)
		OP <=  "111";			--  A*B 
		
		wait for Min_Pulse*3.2;		
		A <= "000000000"; --  (0)
		B <= "110011010"; --  (-102)
		OP <=  "111";			--  A*B 
		wait for Min_Pulse*3.2;		
	
		A <= "110001111"; --  (-113)
		B <= "110011010"; --  (-102)
		OP <=  "111";			--  A*B 
		wait for Min_Pulse*3.2;		

		A <= "001110001"; --  (+113)
		B <= "110011010"; --  (-102)
		OP <=  "111";			--  A*B 
		wait for Min_Pulse*3.2;		

		A <= "110001111"; --  (+113)
		B <= "001100110"; --  (+102)
		OP <=  "110";			--  2C(B) 
		wait for Min_Pulse*3.2;		


		A <= "111111111"; --  (-1)
		B <= "110011010"; --  (-102)
		OP <=  "111";			--  A*B  
		wait for Min_Pulse*3.2;		

-- Let's check the OV
		A <= "011111111"; --  (+255)
		B <= "110011010"; --  (-102)
		OP <=  "100";			--  A+B ---> OV = 0
		wait for Min_Pulse*3.2;		

		A <= "011111111"; --  (+255)
		B <= "110011010"; --  (-102)
		OP <=  "101";			--  A-B ---> OV = 1
		wait for Min_Pulse*3.2;		


		A <= "100000000"; -- (-256)
		B <= "100000001"; -- (-255)
		OP <=  "111";			--  A*B 
		wait for Min_Pulse*3.2;		

		A <= "100000000"; -- (-256)
		B <= "100000001"; -- (-255)
		OP <=  "110";			--  2C(B)
		wait for Min_Pulse*3.2;		
		
		A <= "100000000"; -- (-256)
		B <= "100000001"; -- (-255)
		OP <=  "101";			--  A-B 
		wait for Min_Pulse*3.2;		
	
		A <= "100000000"; -- (-256)
		B <= "100000001"; -- (-255)
		OP <=  "100";			--  A+B 
		wait for Min_Pulse*3.2;			
	

	
		A <= "100000000"; -- (-256)
		B <= "011111111"; -- (+255)
		OP <=  "111";			--  A*B 
		wait for Min_Pulse*3.2;		

		A <= "100000000"; -- (-256)
		B <= "011111111"; -- (+255)
		OP <=  "110";			--  2C(B)
		wait for Min_Pulse*3.2;		
		
		A <= "100000000"; -- (-256)
		B <= "011111111"; -- (+255)
		OP <=  "101";			--  A-B 
		wait for Min_Pulse*3.2;		
	
		A <= "100000000"; -- (-256)
		B <= "011111111"; -- (+255)
		OP <=  "100";			--  A+B 
		wait for Min_Pulse*3.2;			
	








	
-- Let's check the Carry when adding (imagining radix-2)
		A <= "111111111"; -- (511)
		B <= "111111111"; -- (511)
		OP <=  "100";			--  A+B 
		wait for Min_Pulse*3.2;		
	
		--Add other input vectors and solve more operations,
      wait;
   end process;




                                        
END ALU_9bit_arch;
