--------------------------------------------------------------------------------
-- An example of 18-bit adder using a hierarchical structure of components.
-- Plan C2: Two Adder_9bit are chained connecting carries. And adaptation of 
-- the the schematic available at: 
-- https://digsys.upc.edu/csd/P04/lab04/lab4.html#Adder_16bit_RC
---------------------------------------------------
-- Exercise P4 -Lab4 - CSD - Arithmetic circuits and circuit's speed 
-- http://digsys.upc.edu
--------------------------------------------------------------------------------
LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;

ENTITY Adder_18bit IS
	PORT (
		A,B		: IN 	STD_LOGIC_VECTOR(17 DOWNTO 0); 				
		Cin		: IN 	STD_LOGIC;    
		S		: OUT 	STD_LOGIC_VECTOR (17 DOWNTO 0);	
		Cout	: OUT  	STD_LOGIC
	  );

END Adder_18bit;

ARCHITECTURE hierarchical_plan_C2 OF Adder_18bit IS

-- The component to be used:
COMPONENT Adder_9bit IS
	PORT (
		A,B		: IN 	STD_LOGIC_VECTOR(8 DOWNTO 0); 				
		Cin		: IN 	STD_LOGIC;    
		S		: OUT 	STD_LOGIC_VECTOR (8 DOWNTO 0);	
		Cout	: OUT  	STD_LOGIC;
		C8		: OUT  	STD_LOGIC
	  );	
END COMPONENT;

-- Internal signals
	SIGNAL	C9, C8, C17 : STD_LOGIC;	
	
BEGIN

-- Instantiating the 9-bit adders:
chip1: 	Adder_9bit
	PORT MAP (
-- from component	=> to signal or port name
		Cin			=> Cin,			
		A			=> A(8 downto 0),
		B			=> B(8 downto 0),
		S			=> S(8 downto 0),
		C8			=> C8,
		Cout		=> C9 
	);

chip2: 	Adder_9bit
	PORT MAP (
-- from component	=> to signal or port name
		Cin			=> C9,			
		A			=> A(17 downto 9),
		B			=> B(17 downto 9),
		S			=> S(17 downto 9),
		C8			=> C17,	
		Cout		=> Cout 
	);
		
-- Other circuits and equations:

END hierarchical_plan_C2;