--------------------------------------------------------------------------------
-- An example of a 1-bit full adder (Adder_1bit) using simplified logic 
-- equations (structural)
---------------------------------------------------
-- Exercise P3  - CSD - Arithmetic circuits
-- http://digsys.upc.edu
--------------------------------------------------------------------------------


LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;

ENTITY Adder_1bit IS
		PORT (
			Ai,Bi, Ci	: IN STD_LOGIC;				
			So, Co		: OUT STD_LOGIC
		  );
END Adder_1bit;

ARCHITECTURE logic_equations OF Adder_1bit IS
BEGIN

So <= Ai XOR Bi XOR Ci;

-- This is another equation (SoP): 
-- Co <= (Ai AND Bi) OR (Ci AND Ai) OR (Ci AND Bi);

Co <= (Ai AND Bi) OR (Ci AND (Ai OR Bi) );
			 		   	 		 		   	   
END logic_equations;
