--------------------------------------------------------------------------------
-- Example of chip design: Multiplexer of 2 channels: MUX_2
-- Plan B, behavioural --> truth table--> flowchart
---------------------------------------------------
-- Adapted from the MUX_8 plan B tutorial at LAB2: 
-- https://digsys.upc.edu/csd/P02/lab02/lab2.html#PlanB

-- Project P2 - CSD 
-- https://digsys.upc.edu
--------------------------------------------------------------------------------

LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;

ENTITY MUX_2 IS
	PORT (							
		Ch0, Ch1	: 	IN 	STD_LOGIC;  
		S			:	IN 	STD_LOGIC; 
		E			: 	IN 	STD_LOGIC;
		Y			:	OUT	STD_LOGIC
	  );
END MUX_2;

architecture truth_table_flowchart of MUX_2 is

begin   
-- this block defines the flowchart
Y	<= 	Ch0 when (S ='0' and E = '1') else
		Ch1 when (S ='1' and E = '1') else '0';
		
end truth_table_flowchart;