--------------------------------------------------------------------------------
-- UPC - EETAC - CSD 
-- P3 example arithmetic circuit (optional extra material) 
-- 9-bit multiplier for radix 2 numbers (unsigned)
-- Plan B single file behavioural design plan. 
-- Reference lecture and schematics:
-- https://digsys.upc.edu/csd/P03/L03_2/L3_2.html
--------------------------------------------------------------------------------
LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;
-- This library introduces numbers and operators: 
use IEEE.NUMERIC_STD.ALL;
-- use ieee.std_logic_arith.all;
-- use ieee.std_logic_unsigned.all;

entity Mult_9bit is
   port
   (
      A, B:	in	std_logic_vector(8 downto 0);
      P:	out	std_logic_vector(17 downto 0)
   );
end entity Mult_9bit;
 
architecture Behavioral_algorithm of Mult_9bit is
begin
-- Using the arithmetic operator '*', Quartus Prime will find the best circuit
-- considering the target FPGA technology.
   P <= std_logic_vector(unsigned(A) * unsigned(B));
   
end architecture Behavioral_algorithm;

