--------------------------------------------------------------------------------
-- Example of chip design: Nonuple multiplexer of 2 channels: Nonuple_MUX_2
-- Plan B, behavioural --> truth table--> flowchart
---------------------------------------------------
-- Adapted from the Nonuple_MUX_2 plan B tutorial at: 

-- This is the straight translation of the flowchart in:
-- https://digsys.upc.edu/csd/P02/Dual_MUX_4_planB/Dual_MUX_4_planB.html

-- Project P2 - CSD 
-- https://digsys.upc.edu
--------------------------------------------------------------------------------

LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;

ENTITY Nonuple_MUX_2 IS
	PORT (					-- 9 bits is the channel size
		Ch0, Ch1	: 	IN 	STD_LOGIC_VECTOR (8 downto 0);  
							-- 1 bit to select 2 channels
		S			:	IN 	STD_LOGIC; 
		E			: 	IN 	STD_LOGIC;
							-- 9 bits output
		Y			: 	OUT	STD_LOGIC_VECTOR (8 downto 0)
	  );
END Nonuple_MUX_2;

architecture truth_table_flowchart of Nonuple_MUX_2 is

begin   
-- this block defines the flowchart
Y	<= 	Ch0 when (S ='0' and E = '1') else
		Ch1 when (S ='1' and E = '1') else "000000000";
		
end truth_table_flowchart;