--------------------------------------------------------------------------------
-- Example of chip design: Quadruple multiplexer of 2 channels: Quad_MUX_2
-- Plan B, behavioural --> truth table--> flowchart
---------------------------------------------------
-- This is the straight translation of the flowchart in:
-- https://digsys.upc.edu/csd/P02/Dual_MUX_4_planB/Dual_MUX_4_planB.html

-- Project P2 - CSD 
-- https://digsys.upc.edu
--------------------------------------------------------------------------------

LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;

ENTITY Quad_MUX_2 IS
	PORT (					-- 4 bits is the channel size
		Ch0, Ch1	: 	IN 	STD_LOGIC_VECTOR (3 downto 0);  
							-- 1 bit to select 2 channels
		S			:	IN 	STD_LOGIC; 
		E			: 	IN 	STD_LOGIC;
							-- 4 bits output
		Y			: 	OUT	STD_LOGIC_VECTOR (3 downto 0)
	  );
END Quad_MUX_2;

architecture truth_table_flowchart of Quad_MUX_2 is

begin   
-- this block defines the flowchart
Y	<= 	Ch0 when (S ='0' and E = '1') else
		Ch1 when (S ='1' and E = '1') else "0000";
		
end truth_table_flowchart;