--------------------------------------------------------------------------------
-- Exercise P4 -Lab4 - CSD - Prototyping
-- http://digsys.upc.edu
--------------------------------------------------------------------------------
-- An example of 18-bit two's complement circuit to be used in the 
-- multiplier for integer numbers. 
-- Plan C2: An Adder_18bit and also a block of XOR gates. 
-- Schematic in LAB4 prototyping ALU_9bit (Annex)
-- https://digsys.upc.edu/csd/P04/lab04/lab4.html#Prot
--------------------------------------------------------------------------------
LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;

ENTITY Two_C_18bit IS
	PORT (
		A		: IN 	STD_LOGIC_VECTOR(17 DOWNTO 0); 
		Neg 	: IN 	STD_LOGIC;	
		B		: OUT 	STD_LOGIC_VECTOR (17 DOWNTO 0)
	  );
END Two_C_18bit;

ARCHITECTURE hierarchical_plan_C2 OF Two_C_18bit IS

-- The component to be used:
COMPONENT Adder_18bit IS
	PORT (
		A,B		: IN 	STD_LOGIC_VECTOR(17 DOWNTO 0); 				
		Cin		: IN 	STD_LOGIC;    
		S		: OUT 	STD_LOGIC_VECTOR (17 DOWNTO 0);	
		Cout	: OUT  	STD_LOGIC
	  );
END COMPONENT;

-- Internal signals
	SIGNAL	Cout 	: STD_LOGIC;	
	SIGNAL	K 		: STD_LOGIC_VECTOR(17 downto 0);	
	
BEGIN

-- Instantiating the 9-bit adder:
chip1: 	Adder_18bit
	PORT MAP (
-- from component	=> to signal or port name
		Cin			=> Neg,			
		A			=> K,
		B			=> "000000000000000000",
		S			=> B,
		Cout		=> Cout 
	);
--------------------------------------------------------------------------------		
-- The XOR block acting as a NOT/Buffer depending on the sign bit

K(0)  <= Neg xor A(0);
K(1)  <= Neg xor A(1);
K(2)  <= Neg xor A(2);
K(3)  <= Neg xor A(3);
K(4)  <= Neg xor A(4);
K(5)  <= Neg xor A(5);
K(6)  <= Neg xor A(6);
K(7)  <= Neg xor A(7);
K(8)  <= Neg xor A(8);
K(9)  <= Neg xor A(9);
K(10) <= Neg xor A(10);
K(11) <= Neg xor A(11);
K(12) <= Neg xor A(12);
K(13) <= Neg xor A(13);
K(14) <= Neg xor A(14);
K(15) <= Neg xor A(15);
K(16) <= Neg xor A(16);
K(17) <= Neg xor A(17);

END hierarchical_plan_C2;