--------------------------------------------------------------------------------
-- Exercise P4 -Lab4 - CSD - Prototyping
-- http://digsys.upc.edu
--------------------------------------------------------------------------------
-- An example of 9-bit two's complement circuit to be used in the 
-- multiplier for integer numbers. 
-- Plan C2: An Adder_9bit and also a block of xor gates. 
-- Schematic in LAB4 prototyping ALU_9bit (Annex)
-- https://digsys.upc.edu/csd/P04/lab04/lab4.html#Prot
--------------------------------------------------------------------------------
LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;

ENTITY Two_C_9bit IS
	PORT (
		A		: IN 	STD_LOGIC_VECTOR(8 DOWNTO 0); 				
		B		: OUT 	STD_LOGIC_VECTOR (8 DOWNTO 0)
	  );
END Two_C_9bit;

ARCHITECTURE hierarchical_plan_C2 OF Two_C_9bit IS

-- The component to be used:
COMPONENT Adder_9bit IS
	PORT (
		A,B		: IN 	STD_LOGIC_VECTOR(8 DOWNTO 0); 				
		Cin		: IN 	STD_LOGIC;    
		S		: OUT 	STD_LOGIC_VECTOR (8 DOWNTO 0);	
		Cout	: OUT  	STD_LOGIC;
		C8		: OUT  	STD_LOGIC
	  );	
END COMPONENT;

-- Internal signals
	SIGNAL	C9, C8 	: STD_LOGIC;	
	SIGNAL	K 		: STD_LOGIC_VECTOR(8 downto 0);	
	
BEGIN

-- Instantiating the 9-bit adder:
chip1: 	Adder_9bit
	PORT MAP (
-- from component	=> to signal or port name
		Cin			=> A(8),			
		A			=> K,
		B			=> "000000000",
		S			=> B,
		C8			=> C8,
		Cout		=> C9 
	);
--------------------------------------------------------------------------------		
-- The XOR block acting as a NOT/Buffer depending on the sign bit

K(0) <= A(8) xor A(0);
K(1) <= A(8) xor A(1);
K(2) <= A(8) xor A(2);
K(3) <= A(8) xor A(3);
K(4) <= A(8) xor A(4);
K(5) <= A(8) xor A(5);
K(6) <= A(8) xor A(6);
K(7) <= A(8) xor A(7);
K(8) <= A(8) xor A(8);


END hierarchical_plan_C2;